package server

import (
	"asapo_common/utils"
)

var listRoutes = utils.Routes{
	utils.Route{
		"GetNext",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/{groupid}/next",
		routeGetNext,
	},
	utils.Route{
		"GetSize",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/size",
		routeGetSize,
	},
	utils.Route{
		"GetStreams",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/streams",
		routeGetStreams,
	},
	utils.Route{
		"GetLast",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/0/last",
		routeGetLast,
	},
	utils.Route{
		"GetLastAck",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/{groupid}/lastack",
		routeGetLastAck,
	},
	utils.Route{
		"GetNacks",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/{groupid}/nacks",
		routeGetNacks,
	},
	utils.Route{
		"GetID",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/0/{id}",
		routeGetByID,
	},
	utils.Route{
		"GetMeta",
		"Get",
		"/database/{dbname}/{datasource}/{stream}/0/meta/{id}",
		routeGetMeta,
	},
	utils.Route{
		"CreateGroup",
		"Post",
		"/creategroup",
		routeCreateGroupID,
	},
	utils.Route{
		"QueryMessages",
		"Post",
		"/database/{dbname}/{datasource}/{stream}/0/querymessages",
		routeQueryMessages,
	},
	utils.Route{
		"ResetConter",
		"Post",
		"/database/{dbname}/{datasource}/{stream}/{groupid}/resetcounter",
		routeResetCounter,
	},
	utils.Route{
		"MessageOp",
		"Post",
		"/database/{dbname}/{datasource}/{stream}/{groupid}/{id}",
		routeMessageOp,
	},
	utils.Route{
		"Health",
		"Get",
		"/health",
		routeGetHealth,
	},
}
